<template>
  <div class="wrapper">
    <div v-if="register" class="box auth-box">
      <h2>Регистрация</h2>
      <label>
        <h3>Логин</h3>
        <input type="text" v-model="username">
        <h3>Пароль</h3>
        <input type="password" v-model="password">
        <h3>e-mail</h3>
        <input type="text" v-model="email">
      </label>
      <button @click="register_action">Регистрация</button>
    </div>
    <div v-else class="box auth-box">
      <h2>Пожалуйста, представьтесь</h2>
      <label>
        <h3>Логин</h3>
        <input type="text" v-model="username">
        <h3>Пароль</h3>
        <input type="password" v-model="password">
        <router-link style="grid-column: 2" to="/register/">Регистрация</router-link>
      </label>
      <button @click="log_in">Войти</button>
    </div>
  </div>
</template>

<script>
  import axios from 'axios';
  import router from '../router'
  export default {
    name: "Auth",
    props: ["register"],
    data() {
      return {
        username: null,
        password: null,
        email: null,
      }
    },
    methods: {
      log_in() {
        let creds = new FormData();
        creds.set('username', this.username);
        creds.set('password', this.password);
        axios.post(`${this.$hostname}/api/token/`, creds).then((response) => {
          const token = response.data.access_token;
          this.$root.$emit('loggedIn', token);
          router.push({name: 'home'});
        }).catch((error) => {
          alert(error);
        })
      },
      register_action() {
        axios.post(`${this.$hostname}/api/user/register/`, {
          email: this.email,
          username: this.username,
          password: this.password
        }).then((response) => {
          const user = response.data;
          this.$root.$emit('registered', user);
          this.$root.$emit('loggedIn', user.access_token);
          router.push({name: 'home'});
        }).catch((error) => {
          alert(error);
        })
      }
    }
  }
</script>

<style scoped>
.wrapper {
  height: 100%;
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
  align-items: center;
  justify-content: center;
}

.auth-box {
  height: 300px;
  width: 440px;
  display: grid;
  grid-template-rows: 20% auto 20%;
  grid-template-columns: auto;
  grid-row-gap: 10px;
  align-items: center;
  justify-content: center;
}

label {
  display: grid;
  grid-template-rows: 1fr 1fr;
  grid-template-columns: 30% auto;
  align-items: center;
  justify-content: center;
  grid-row-gap: 5px;
  grid-column-gap: 10px;
  grid-auto-rows: auto;
}

label > h3 {
  justify-self: end;
}

/* todo: move common styles to CSS file */
.box {
  border-radius: 20px;
  border: 2px solid black;
  padding: 20px;
  background-color: #0f0f0f;
}
</style>
